/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /home/takenaka/hark-ros-stacks-indigo/src/hark_common_msgs/hark_params/msg/SourceTracker.msg
 *
 */


#ifndef HARK_PARAMS_MESSAGE_SOURCETRACKER_H
#define HARK_PARAMS_MESSAGE_SOURCETRACKER_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>


namespace hark_params
{
template <class ContainerAllocator>
struct SourceTracker_
{
  typedef SourceTracker_<ContainerAllocator> Type;

  SourceTracker_()
    : thresh(0.0)
    , pause_length(0.0)
    , min_src_interval(0.0)
    , min_tfindex_interval(0.0)
    , compare_mode(0)  {
    }
  SourceTracker_(const ContainerAllocator& _alloc)
    : thresh(0.0)
    , pause_length(0.0)
    , min_src_interval(0.0)
    , min_tfindex_interval(0.0)
    , compare_mode(0)  {
    }



   typedef float _thresh_type;
  _thresh_type thresh;

   typedef float _pause_length_type;
  _pause_length_type pause_length;

   typedef float _min_src_interval_type;
  _min_src_interval_type min_src_interval;

   typedef float _min_tfindex_interval_type;
  _min_tfindex_interval_type min_tfindex_interval;

   typedef uint8_t _compare_mode_type;
  _compare_mode_type compare_mode;


    enum { DEG = 0u };
     enum { TFINDEX = 1u };
 

  typedef boost::shared_ptr< ::hark_params::SourceTracker_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::hark_params::SourceTracker_<ContainerAllocator> const> ConstPtr;

}; // struct SourceTracker_

typedef ::hark_params::SourceTracker_<std::allocator<void> > SourceTracker;

typedef boost::shared_ptr< ::hark_params::SourceTracker > SourceTrackerPtr;
typedef boost::shared_ptr< ::hark_params::SourceTracker const> SourceTrackerConstPtr;

// constants requiring out of line definition

   

   



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::hark_params::SourceTracker_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::hark_params::SourceTracker_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace hark_params

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': True, 'IsMessage': True, 'HasHeader': False}
// {'hark_msgs': ['/home/takenaka/hark-ros-stacks-indigo/src/hark_common_msgs/hark_msgs/msg'], 'hark_params': ['/home/takenaka/hark-ros-stacks-indigo/src/hark_common_msgs/hark_params/msg'], 'std_msgs': ['/opt/ros/indigo/share/std_msgs/cmake/../msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::hark_params::SourceTracker_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::hark_params::SourceTracker_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::hark_params::SourceTracker_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::hark_params::SourceTracker_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::hark_params::SourceTracker_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::hark_params::SourceTracker_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::hark_params::SourceTracker_<ContainerAllocator> >
{
  static const char* value()
  {
    return "0e5eca4812a7b46014118d0b366889e2";
  }

  static const char* value(const ::hark_params::SourceTracker_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0x0e5eca4812a7b460ULL;
  static const uint64_t static_value2 = 0x14118d0b366889e2ULL;
};

template<class ContainerAllocator>
struct DataType< ::hark_params::SourceTracker_<ContainerAllocator> >
{
  static const char* value()
  {
    return "hark_params/SourceTracker";
  }

  static const char* value(const ::hark_params::SourceTracker_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::hark_params::SourceTracker_<ContainerAllocator> >
{
  static const char* value()
  {
    return "float32 thresh\n\
float32 pause_length\n\
float32 min_src_interval\n\
float32 min_tfindex_interval\n\
uint8 compare_mode\n\
uint8 DEG=0\n\
uint8 TFINDEX=1\n\
";
  }

  static const char* value(const ::hark_params::SourceTracker_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::hark_params::SourceTracker_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.thresh);
      stream.next(m.pause_length);
      stream.next(m.min_src_interval);
      stream.next(m.min_tfindex_interval);
      stream.next(m.compare_mode);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct SourceTracker_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::hark_params::SourceTracker_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::hark_params::SourceTracker_<ContainerAllocator>& v)
  {
    s << indent << "thresh: ";
    Printer<float>::stream(s, indent + "  ", v.thresh);
    s << indent << "pause_length: ";
    Printer<float>::stream(s, indent + "  ", v.pause_length);
    s << indent << "min_src_interval: ";
    Printer<float>::stream(s, indent + "  ", v.min_src_interval);
    s << indent << "min_tfindex_interval: ";
    Printer<float>::stream(s, indent + "  ", v.min_tfindex_interval);
    s << indent << "compare_mode: ";
    Printer<uint8_t>::stream(s, indent + "  ", v.compare_mode);
  }
};

} // namespace message_operations
} // namespace ros

#endif // HARK_PARAMS_MESSAGE_SOURCETRACKER_H
