/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /home/takenaka/hark-ros-stacks-indigo/src/hark_common_msgs/hark_params/msg/HRLE.msg
 *
 */


#ifndef HARK_PARAMS_MESSAGE_HRLE_H
#define HARK_PARAMS_MESSAGE_HRLE_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>


namespace hark_params
{
template <class ContainerAllocator>
struct HRLE_
{
  typedef HRLE_<ContainerAllocator> Type;

  HRLE_()
    : lx(0.0)
    , time_constant(0.0)  {
    }
  HRLE_(const ContainerAllocator& _alloc)
    : lx(0.0)
    , time_constant(0.0)  {
    }



   typedef float _lx_type;
  _lx_type lx;

   typedef float _time_constant_type;
  _time_constant_type time_constant;




  typedef boost::shared_ptr< ::hark_params::HRLE_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::hark_params::HRLE_<ContainerAllocator> const> ConstPtr;

}; // struct HRLE_

typedef ::hark_params::HRLE_<std::allocator<void> > HRLE;

typedef boost::shared_ptr< ::hark_params::HRLE > HRLEPtr;
typedef boost::shared_ptr< ::hark_params::HRLE const> HRLEConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::hark_params::HRLE_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::hark_params::HRLE_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace hark_params

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': True, 'IsMessage': True, 'HasHeader': False}
// {'hark_msgs': ['/home/takenaka/hark-ros-stacks-indigo/src/hark_common_msgs/hark_msgs/msg'], 'hark_params': ['/home/takenaka/hark-ros-stacks-indigo/src/hark_common_msgs/hark_params/msg'], 'std_msgs': ['/opt/ros/indigo/share/std_msgs/cmake/../msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::hark_params::HRLE_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::hark_params::HRLE_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::hark_params::HRLE_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::hark_params::HRLE_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::hark_params::HRLE_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::hark_params::HRLE_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::hark_params::HRLE_<ContainerAllocator> >
{
  static const char* value()
  {
    return "d573ce11b1610cdf85e2c98f807f43dc";
  }

  static const char* value(const ::hark_params::HRLE_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0xd573ce11b1610cdfULL;
  static const uint64_t static_value2 = 0x85e2c98f807f43dcULL;
};

template<class ContainerAllocator>
struct DataType< ::hark_params::HRLE_<ContainerAllocator> >
{
  static const char* value()
  {
    return "hark_params/HRLE";
  }

  static const char* value(const ::hark_params::HRLE_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::hark_params::HRLE_<ContainerAllocator> >
{
  static const char* value()
  {
    return "float32 lx\n\
float32 time_constant\n\
";
  }

  static const char* value(const ::hark_params::HRLE_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::hark_params::HRLE_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.lx);
      stream.next(m.time_constant);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct HRLE_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::hark_params::HRLE_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::hark_params::HRLE_<ContainerAllocator>& v)
  {
    s << indent << "lx: ";
    Printer<float>::stream(s, indent + "  ", v.lx);
    s << indent << "time_constant: ";
    Printer<float>::stream(s, indent + "  ", v.time_constant);
  }
};

} // namespace message_operations
} // namespace ros

#endif // HARK_PARAMS_MESSAGE_HRLE_H
